import { isArray as O, classOf as j, nameOf as b, isBoolean as A, isClass as P, isNil as M, objectKeys as k, isEmpty as G } from "@tsed/core";
import { JsonEntityStore as I, getPropertiesStores as C, JsonParameterStore as v } from "@tsed/schema";
import { alterAfterDeserialize as x } from "../hooks/alterAfterDeserialize.js";
import { alterBeforeDeserialize as B } from "../hooks/alterBeforeDeserialize.js";
import { alterOnDeserialize as E } from "../hooks/alterOnDeserialize.js";
import { JsonMapperCompiler as J } from "./JsonMapperCompiler.js";
import { JsonMapperSettings as w } from "./JsonMapperSettings.js";
import { getJsonMapperTypes as K } from "./JsonMapperTypesContainer.js";
import { Writer as f } from "./Writer.js";
function N(l, e) {
  return e.collectionType && M(l) || l === void 0 ? !1 : !(G(e.type) || e.type === Object && !e.collectionType);
}
function d(l) {
  return `__${l}`;
}
function U(l, e) {
  return {
    ...e,
    store: void 0,
    type: l.getBestType(),
    collectionType: l.collectionType,
    groups: l.parameter.groups,
    // genericTypes: store.nestedGenerics[0],
    generics: l.nestedGenerics
  };
}
function W(l) {
  return l.parent.schema.genericLabels.indexOf(l.itemSchema.genericType);
}
class X extends J {
  constructor() {
    super(), this.constructors = {}, this.addGlobal("newInstanceOf", this.newInstanceOf.bind(this)), this.addGlobal("alterBeforeDeserialize", this.alterBeforeDeserialize.bind(this)), this.addGlobal("alterAfterDeserialize", this.alterAfterDeserialize.bind(this)), this.addTypeMapper(Object, this.mapObject.bind(this)), this.addTypeMapper(Array, this.mapArray.bind(this)), this.addTypeMapper(Map, this.mapMap.bind(this)), this.addTypeMapper(Set, this.mapSet.bind(this)), this.addTypeMapper("ObjectId", (e) => String(e));
  }
  map(e, i = {}) {
    if (i = this.mapOptions(i), !N(e, i))
      return e;
    !i.collectionType && O(e) && (i.collectionType = Array);
    const s = i.type || j(e), t = this.compile(s, i.groups);
    return i.collectionType ? this.compile(i.collectionType, i.groups).fn(e, { ...i, id: t.id }) : t.fn(e, this.createContext(i));
  }
  compile(e, i) {
    if ([WeakMap, WeakSet].includes(e))
      throw new Error(`${b(e)} is not supported by JsonMapper.`);
    return super.compile(e, i);
  }
  eval(e, {
    id: i,
    groupsId: s,
    model: t
  }) {
    return this.constructors[i] = t, super.eval(e, { id: i, groupsId: s, model: t });
  }
  newInstanceOf(e, i, s) {
    try {
      return new this.constructors[e](s.disableUnsecureConstructor ? {} : i);
    } catch {
      return i;
    }
  }
  createMapper(e, i, s) {
    var o, p, h;
    const t = I.from(e), n = /* @__PURE__ */ new Set(), c = [...C(t).values()], r = new f().arrow("input", "options");
    return r.if("isNil(input)").return("input"), t.schema.hasDiscriminator && r.add(this.mapDiscriminator(t, s)), (o = t.schema.$hooks) != null && o.has("beforeDeserialize") && (this.schemes[i] = t.schema, r.set("input", `alterBeforeDeserialize('${i}', input, options)`)), r.const("generics", "options.generics[0]"), (p = t.schema.genericLabels) != null && p.length ? r.set("options", "{...options, self: input, generics: [...options.generics].slice(1)}") : r.set("options", "{...options, self: input}"), r.const("obj", `newInstanceOf('${i}', input, options)`), r.add(
      ...c.flatMap((a) => {
        var m, y, g, $;
        const u = a.propertyName;
        if (n.add(String(a.parent.schema.getAliasOf(u) || u)), !((m = a.schema) != null && m.$ignore && A((y = a.schema) == null ? void 0 : y.$ignore) || a.isGetterOnly() || ($ = (g = a.schema) == null ? void 0 : g.$hooks) != null && $.has("groups") && this.alterGroups(a.schema, s)))
          return this.mapProperty(a, i, s);
      })
    ), r.add(this.mapAdditionalProperties(t, n, s)), (h = t.schema.$hooks) != null && h.has("afterDeserialize") ? (this.schemes[i] = t.schema, r.return(`alterAfterDeserialize('${i}', obj, options)`).root().toString()) : r.return("obj").root().toString();
  }
  alterValue(e, i, s) {
    return E(this.schemes[e], i, s);
  }
  mapDiscriminator(e, i) {
    const s = new f(), t = e.schema.discriminator(), n = s.switch(`input['${t.propertyName}']`);
    return t.values.forEach((c, r) => {
      const o = this.compile(c, i);
      n.case(`'${r}'`).returnCallMapper(o.id, "input");
    }), s;
  }
  mapProperty(e, i, s) {
    var g, $, D, T;
    const t = String(e.propertyKey), n = String(e.parent.schema.getAliasOf(t) || t), c = this.getSchemaId(i, t), r = e.itemSchema.get("format"), o = r && `options: {format: '${r}'}`;
    let p = new f().add(`// Map ${t} ${i} ${s || ""}`);
    const h = t !== n ? `options.useAlias ? '${n}' : '${t}'` : `'${t}'`;
    ($ = (g = e.schema) == null ? void 0 : g.$hooks) != null && $.has("ignore") && (this.schemes[c] = e.schema, p = p.if(`!alterIgnore('${c}', {...options, self: input})`));
    const a = (T = (D = e.schema) == null ? void 0 : D.$hooks) == null ? void 0 : T.has("onDeserialize");
    let u = `input[${h}]`;
    if (a) {
      this.schemes[c] = e.schema;
      const z = f.options(o);
      u = `alterValue('${c}', input[${h}], ${z})`;
    }
    const m = p.set(`let ${d(t)}`, u).if(`${d(t)} !== undefined`), y = this.getPropertyFiller(e, i, s, o);
    return y(a ? m.if(`${d(t)} === input.${t}`) : m), m.set(`obj.${t}`, d(t)), s && s.includes("partial") && m.else().add(`delete obj.${t}`), p.root();
  }
  getPropertyFiller(e, i, s, t) {
    const n = String(e.propertyKey), c = this.getSchemaId(i, n), r = e.itemSchema.nestedGenerics;
    if (e.itemSchema.isGeneric && !(r != null && r.length)) {
      const a = W(e), u = f.options(t, `type: generics[${a}]`);
      return (m) => m.set(d(n), `compileAndMap(${d(n)}, ${u})`);
    }
    const p = e.itemSchema.hasDiscriminator ? e.itemSchema.discriminator().base : e.getBestType(), h = this.compile(p, s);
    return e.isCollection ? (a) => a.callMapper(b(e.collectionType), d(n), `id: '${h.id}'`, t) : r != null && r.length ? (this.schemes[c] = e.schema, (a) => a.callMapper(h.id, d(n), t, `generics: schemes['${c}'].nestedGenerics`)) : (a) => a.callMapper(h.id, d(n), t);
  }
  mapOptions({ groups: e, useAlias: i = !0, types: s, ...t }) {
    if (t.store instanceof v)
      return this.mapOptions(U(t.store, t));
    const n = {};
    s = s || K(), s.forEach((r, o) => {
      if (![Array, Set, Map].includes(o)) {
        const p = b(o);
        b(o) in r ? this.addTypeMapper(o, r[p].bind(r)) : this.addTypeMapper(
          o,
          (h, a) => r.deserialize(h, {
            ...a,
            type: o
          })
        );
      }
    });
    const c = t.strictGroups ?? w.strictGroups;
    return {
      ...t,
      additionalProperties: t.additionalProperties ?? w.additionalProperties,
      disableUnsecureConstructor: t.disableUnsecureConstructor ?? w.disableUnsecureConstructor,
      groups: e === void 0 ? c ? [] : !1 : e || !1,
      useAlias: i,
      customMappers: n,
      generics: t.generics || []
    };
  }
  mapAdditionalProperties(e, i, s) {
    const t = e.schema.get("additionalProperties"), n = [...i.values()].map((o) => `'${o}'`).join(", "), c = new f();
    c.add("// add additional properties");
    let r = c.each("objectKeys(input)", ["key"]);
    if (n.length && (r = r.if(`![${n}].includes(key)`)), P(t)) {
      const o = this.compile(t.getComputedType(), s);
      return r.set("obj[key]", f.mapper(o.id, "input[key]", "options")), c;
    }
    return t ? (r.set("obj[key]", "input[key]"), c) : (r.if("options.additionalProperties && obj[key] === undefined").set("obj[key]", "input[key]"), c);
  }
  mapObject(e, i) {
    return e;
  }
  mapSet(e, i) {
    if (M(e))
      return e;
    const s = /* @__PURE__ */ new Set();
    return k(e).forEach((t) => {
      s.add(this.mapItem(e[t], i));
    }), s;
  }
  mapArray(e, i) {
    return M(e) ? e : [].concat(e).map((s) => this.mapItem(s, i));
  }
  mapMap(e, i) {
    if (M(e))
      return e;
    const s = /* @__PURE__ */ new Map();
    return k(e).forEach((t) => {
      s.set(t, this.mapItem(e[t], i));
    }), s;
  }
  mapItem(e, { id: i, ...s }) {
    return this.execMapper(i, e, s);
  }
  alterBeforeDeserialize(e, i, s) {
    return B(i, this.schemes[e], s);
  }
  alterAfterDeserialize(e, i, s) {
    return x(i, this.schemes[e], s);
  }
}
export {
  X as JsonDeserializer
};
//# sourceMappingURL=JsonDeserializer.js.map
