import { isNil as u, isBoolean as N, nameOf as $, isPrimitive as P, isCollection as w, hasJsonMethod as J, classOf as M, isMongooseObject as A, isDate as T, isMomentObject as D, isObject as S, isClassObject as x, isArray as C } from "@tsed/core";
import { JsonEntityStore as I, getPropertiesStores as G } from "@tsed/schema";
import { alterOnSerialize as K } from "../hooks/alterOnSerialize.js";
import { getObjectProperties as v } from "../utils/getObjectProperties.js";
import { JsonMapperCompiler as z } from "./JsonMapperCompiler.js";
import { JsonMapperSettings as V } from "./JsonMapperSettings.js";
import { getJsonMapperTypes as B } from "./JsonMapperTypesContainer.js";
import { Writer as l } from "./Writer.js";
const k = (h) => C(h) ? "Array" : h instanceof Set ? "Set" : h instanceof Map ? "Map" : void 0;
function E(h, e) {
  const t = M(e);
  return t && !x(t) && !w(e) ? t : h || Object;
}
function p(h) {
  return `__${h}`;
}
class U extends z {
  constructor() {
    super(), this.addTypeMapper(Object, this.mapObject.bind(this)), this.addTypeMapper(Array, this.mapArray.bind(this)), this.addTypeMapper(Map, this.mapMap.bind(this)), this.addTypeMapper(Set, this.mapSet.bind(this)), this.addGlobal("mapJSON", this.mapJSON.bind(this)), this.addTypeMapper("ObjectId", (e) => String(e));
  }
  map(e, t = {}) {
    if (u(e))
      return e;
    t = this.mapOptions(t);
    const r = E(t.type, e);
    return this.compile(r, t.groups).fn(e, this.createContext(t));
  }
  alterValue(e, t, r) {
    return K(this.schemes[e], t, r);
  }
  createMapper(e, t, r) {
    const i = I.from(e), n = /* @__PURE__ */ new Set(), a = [...G(i).values()], o = new l().arrow("input", "options");
    return o.if("isNil(input)").return("input"), o.const("obj", "{}"), o.set("options", "{...options, self: input}"), o.add(this.mapPrecondition(t)), a.length ? (o.add(
      ...a.flatMap((s) => {
        var c, m, d, f;
        if (n.add(s.propertyKey), !((c = s.schema) != null && c.$ignore && N((m = s.schema) == null ? void 0 : m.$ignore) || (f = (d = s.schema) == null ? void 0 : d.$hooks) != null && f.has("groups") && this.alterGroups(s.schema, r)))
          return this.mapProperty(s, t, r);
      })
    ), o.add(this.mapDiscriminatorKeyValue(i)), o.add(this.mapAdditionalProperties(i, n)), o.return("obj").root().toString()) : o.return("isObject(input) ? {...input} : input").root().toString();
  }
  mapOptions({ groups: e, useAlias: t = !0, types: r, ...i }) {
    const n = {};
    r = r || B(), r.forEach((o, s) => {
      [Array, Set, Map].includes(s) || this.addTypeMapper(
        s,
        (c, m) => o.serialize(c, {
          ...m,
          type: s
        })
      );
    });
    const a = i.strictGroups ?? V.strictGroups;
    return {
      ...i,
      groups: e === void 0 ? a ? [] : !1 : e || !1,
      useAlias: t,
      customMappers: n
    };
  }
  mapProperty(e, t, r) {
    var g, O, b, j;
    const i = String(e.propertyKey), n = String(e.parent.schema.getAliasOf(i) || i), a = this.getSchemaId(t, i), o = e.itemSchema.get("format"), s = o && `options: {format: '${o}'}`;
    let c = new l().add(`// Map ${i} ${t} ${r || ""}`);
    (O = (g = e.schema) == null ? void 0 : g.$hooks) != null && O.has("ignore") && (this.schemes[a] = e.schema, c = c.if(`!alterIgnore('${a}', {...options, self: input})`));
    const m = (j = (b = e.schema) == null ? void 0 : b.$hooks) == null ? void 0 : j.has("onSerialize");
    let d = `input.${i}`;
    if (m) {
      this.schemes[a] = e.schema;
      const y = l.options(s);
      d = `alterValue('${a}', input.${i}, ${y})`;
    }
    c = c.set(`let ${p(i)}`, d).if(`${p(i)} !== undefined`);
    const f = this.getPropertyFiller(e, i, r, s);
    return f(m ? c.if(`${p(i)} === input.${i}`) : c), n !== i ? c.set(`obj[options.useAlias ? '${n}' : '${i}']`, p(i)) : c.set(`obj.${i}`, p(i)), c.root();
  }
  getPropertyFiller(e, t, r, i) {
    const n = e.itemSchema.isGeneric, a = e.itemSchema.hasDiscriminator;
    if (e.isCollection) {
      const s = e.getBestType();
      let c;
      if (a) {
        const m = e.parent.targetName;
        c = this.compile(`Discriminator:${m}:${t}`, r, {
          mapper: () => this.createDiscriminatorMapper(e, r)
        });
      } else
        c = n ? { id: "" } : this.compile(s, r);
      return (m) => m.callMapper($(e.collectionType), p(t), `id: '${c.id}'`, i);
    }
    if (n)
      return (s) => s.set(p(t), `compileAndMap(${p(t)}, options)`);
    let o;
    if (a) {
      const s = e.parent.targetName;
      o = this.compile(`Discriminator:${s}:${t}`, r, {
        mapper: () => this.createDiscriminatorMapper(e, r)
      });
    } else
      o = this.compile(e.getBestType(), r);
    return (s) => s.callMapper(o.id, p(t), i);
  }
  createDiscriminatorMapper(e, t) {
    const r = e.itemSchema.discriminator(), i = new l().arrow("input", "options"), n = i.switch("nameOf(classOf(input))");
    return r.values.forEach((a, o) => {
      const s = this.compile(a, t);
      n.case(`'${$(a)}'`).returnCallMapper(s.id, "input");
    }), i.root().toString();
  }
  mapPrecondition(e) {
    const t = new l();
    return t.if("input && isCollection(input)").return(l.mapperFrom("input", `{...options, id: '${e}'}`)), t.if("hasJsonMethod(input)").return(`mapJSON(input, {...options, id: '${e}'})`), t;
  }
  mapDiscriminatorKeyValue(e) {
    if (e.discriminatorAncestor) {
      const t = e.discriminatorAncestor.schema.discriminator(), r = t.getDefaultValue(e.target);
      if (r) {
        const i = new l();
        return i.if(`!obj.${t.propertyName}`).set(`obj.${t.propertyName}`, `'${r}'`), i;
      }
    }
  }
  mapAdditionalProperties(e, t) {
    if (!!e.schema.get("additionalProperties")) {
      const i = [...t.values()].map((a) => `'${a}'`).join(", "), n = new l();
      return n.add("// add additional properties"), n.each("objectKeys(input)", ["key"]).if(`![${i}].includes(key)`).set("obj[key]", "input[key]"), n;
    }
  }
  mapObject(e, { type: t, ...r }) {
    return e && P(e) || !e ? e : e && w(e) ? this.execMapper(k(e), e, r) : J(e) ? this.mapJSON(e, r) : v(e).filter(([, i]) => i !== void 0).reduce((i, [n, a]) => {
      if (u(a))
        return {
          ...i,
          [n]: a
        };
      const o = this.compile(M(a), r.groups);
      return {
        ...i,
        [n]: o.fn(a, r)
      };
    }, {});
  }
  mapSet(e, t) {
    return u(e) ? e : [...e.values()].map((r) => this.mapItem(r, t));
  }
  mapArray(e, t) {
    return u(e) ? e : [].concat(e).map((r) => this.mapItem(r, t));
  }
  mapMap(e, t) {
    return u(e) ? e : [...e.entries()].reduce((r, [i, n]) => ({
      ...r,
      [i]: this.mapItem(n, t)
    }), {});
  }
  mapItem(e, { id: t, ...r }) {
    return !t && e ? this.compile(M(e), r.groups).fn(e, r) : t ? this.execMapper(t, e, r) : e;
  }
  mapJSON(e, { id: t, ...r }) {
    return A(e) ? e.toJSON({ ...r, self: void 0, id: t }) : (t = t || $(M(e)), this.mappers[t] && (T(e) || D(e)) ? this.execMapper(t, e, r) : (e = e.toJSON(), S(e) ? this.execMapper(t, e, r) : e));
  }
}
export {
  U as JsonSerializer
};
//# sourceMappingURL=JsonSerializer.js.map
