import { JsonEntityFn } from "@tsed/schema";
/**
 * Call the function before property serialization.
 *
 * ## Example
 *
 * ```typescript
 * class Model {
 *    @OnSerialize(v => v + 1)
 *    property: string;
 * }
 * ```
 *
 * @returns {Function}
 * @decorator
 * @schema
 * @property
 * @param cb
 */
export function OnSerialize(cb) {
    return JsonEntityFn((storedJson) => {
        storedJson.schema.$hooks.on("onSerialize", cb);
    });
}
//# sourceMappingURL=onSerialize.js.map